package Cliente.Transformacional;

import CWMTransformation.*;
import CWMTransformationImpl.*;
import Core.*;
import CoreImpl.*;
import Cliente.Util.PrintUtil;

import org.omg.CORBA.ORB;
import Cliente.Util.IorUtils;

import java.sql.Date;
import java.sql.Timestamp;

public class Cliente2 {

private static final String FACTORY_IOR_FILE = "Transformation.ior";
private static final String FACTORY_IOR_FILE_CORE = "Core.ior";
private static final String FACTORY_IOR_FILE_NEW = "TransformationNew.ior";
private static org.omg.CORBA.ORB orb;


  static public void init(String msg){
    try {
      PrintUtil.Debug("Recibi el mensaje: " + msg);
      // Initialize the ORB.
      orb = org.omg.CORBA.ORB.init((String[])null, null);
      IorUtils iorUtils = new IorUtils(orb);

      PrintUtil.Debug("Leyendo Transformation...");
      org.omg.CORBA.Object obj;
      obj = iorUtils.readIOR(FACTORY_IOR_FILE);
      PrintUtil.Debug("Leyendo Core...");
      org.omg.CORBA.Object objCore;
      objCore = iorUtils.readIOR(FACTORY_IOR_FILE_CORE);
      PrintUtil.Debug("Ejecutando...");
      //Se obtiene la interfaz remota
      CWMTransformationPackageFactory factory =
        CWMTransformationPackageFactoryHelper.narrow(obj);
    }
    catch (Exception ex) {  ex.printStackTrace(); }
  }
  static public void main(String[] args) {
    _CWMTransformationPackage pkg;
    _CorePackage pkgCore;
    ManejoPackage mp = new ManejoPackage();

    PrintUtil.Debug("Inicializando...");
    try {
      // Initialize the ORB.
      orb = org.omg.CORBA.ORB.init(/*args*/(String[])null, null);
      IorUtils iorUtils = new IorUtils(orb);
      PrintUtil.Debug("Leyendo Transformation...");
      org.omg.CORBA.Object obj;
      obj = iorUtils.readIOR(FACTORY_IOR_FILE);
      PrintUtil.Debug("Leyendo Core...");
      org.omg.CORBA.Object objCore;
      objCore = iorUtils.readIOR(FACTORY_IOR_FILE_CORE);
      PrintUtil.Debug("Ejecutando...");
      //Se obtiene la interfaz remota
      CWMTransformationPackageFactory factory =
        CWMTransformationPackageFactoryHelper.narrow(obj);

      /*Se crea el paquete transformation*/
      pkg = factory.create_cwmtransformation_package();

      /*Se crean los dataObjects*/
      DataObjectSet dataObjectSet1  =
        mp.crearDataObject("Data_1",Core.VisibilityKind.vk_public,pkg);

      DataObjectSet dataObjectSet2  =
        mp.crearDataObject("Data_2",Core.VisibilityKind.vk_public,pkg);

      DataObjectSet dataObjectSet3  =
        mp.crearDataObject("Data_3",Core.VisibilityKind.vk_public,pkg);

      /*Se crea el procedure expression*/
      CorePackageFactory factoryCore = CorePackageFactoryHelper.narrow(objCore);
      pkgCore  = factoryCore.create_core_package();

      String [] leng = {"sql"};
      ProcedureExpression pe =
        pkgCore.procedure_expression_ref().create_procedure_expression(
                  "SELECT * FROM TradesSource",leng);

      /*Se crea la transformacion*/
      Transformation t = mp.crearTransformacion("TRDExtractor",
                              Core.VisibilityKind.vk_public,
                              pe,"Consulta de la tabla de trades",true,pkg);
      /*Se asocian el fuente y destino a la transformacion*/
      t.add_source(dataObjectSet1);
      t.add_target(dataObjectSet2);

      /*Se crea un transformation task*/
      TransformationTask task = pkg.transformation_task_ref().create_transformation_task(
        "Tarea1",Core.VisibilityKind.vk_public,false);
      /*Se asocian esta tarea el transformation task creado anteriormente*/
      task.add_transformation(t);

      /*Se crea un paso*/
      TransformationStep step =
                  pkg.transformation_step_ref().create_transformation_step(
                  "Paso_1",Core.VisibilityKind.vk_public);

      /*Se asocian este paso a la tarea creada anteriormente*/
      step.set_task(task);

      /*Se crea la Actividad*/
      TransformationActivity actividad =
                  pkg.transformation_activity_ref().create_transformation_activity(
                  "Actividad_1",Core.VisibilityKind.vk_public,false,
                  new Timestamp(System.currentTimeMillis()).toString());
      ModelElement [] elems = {(ModelElement)step};
      actividad.set_step(elems);







      ProcedureExpression pe2 =
        pkgCore.procedure_expression_ref().create_procedure_expression(
                  "SELECT * FROM TradesSource WHERE Sales < 4",leng);
      /*Se crea otra transformacion*/
      Transformation t2 = pkg.transformation_ref().create_transformation(
                              "DEC97Trades",
                              Core.VisibilityKind.vk_public,
                              pe2,"Filtro de la tabla de trades",false);
      /*Se asocian el fuente y destino a la transformacion*/
      t2.add_source(dataObjectSet2);
      t2.add_target(dataObjectSet3);
      task.add_transformation(t2);


      /*Se crea otro paso*/
      TransformationStep step2 =
                  pkg.transformation_step_ref().create_transformation_step(
                  "Paso_2",Core.VisibilityKind.vk_public);
      /*Se asocian este paso a la tarea creada anteriormente*/
      step.set_task(task);

      String [] kind = {"Usage"};
      StepPrecedence stepPrec =
        pkg.step_precedence_ref().create_step_precedence("precedencia1",
          Core.VisibilityKind.vk_public, kind);



      //Elems tiene solo al paso step
      stepPrec.set_preceding_step(elems);

      ModelElement [] elems2 = {step2};
      stepPrec.set_succeeding_step(elems2);


      PrintUtil.PrintPackageTransformacional(pkg);

      //Se guarda el objeto en el archivo ior.
      iorUtils.writeIOR(pkg, FACTORY_IOR_FILE_NEW);

    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }





}