package Cliente.Util;
/*
 * IOR file utilities class for the Trader example clients.
 */

import java.io.*;
import java.net.*;
import Servidor.*;

import CWMTransformation.*;
import CWMTransformationImpl.*;
import Core.*;
import CoreImpl.*;
import java.util.Properties;

public class IorUtils {

  private org.omg.CORBA.ORB orb;
  private static final String IOR_SERVIDOR_T5 ="http://olimpia:9091/ServidorT5.ior";
  private static final String FACTORY_IOR_FILE = "http://olimpia:9091/Transformation.ior";
  private static final String FACTORY_IOR_FILE_CORE = "http://olimpia:9091/Core.ior";
  private Servicios serv;
  private static Properties property = null;

  public org.omg.CORBA.ORB getORB(){
    return orb;
  }
  public IorUtils(org.omg.CORBA.ORB orb) throws Exception{
    property = new Properties();
    property.load(new FileInputStream("client.properties"));
    orb = org.omg.CORBA.ORB.init((String[])null, property);
    this.orb = orb;
  }

  public String getNewRefIOR(String nombreCliente){
    //Lee el archivo ServidorT5.ior
    org.omg.CORBA.Object objT5 = readIORRemote(IOR_SERVIDOR_T5);
    //Obtiene una referencia al servicio de ServidorT5
    serv = ServiciosHelper.narrow(objT5);
    //Pide un nombre de ior (se le asigna uno randomico)
    String REPOS_IOR_FILE = serv.getNameIOR(nombreCliente);
    return REPOS_IOR_FILE;
  }

  public void storeRef(String nameRef,String object){
    serv.writeIOR(nameRef,object);
  }
  public Object loadNewRefPkg(String clasePackageHelper) throws Reflective.MofError{
    if (clasePackageHelper.equals("_CWMTransformationPackage")){
      org.omg.CORBA.Object obj = readIORRemote(FACTORY_IOR_FILE);
      CWMTransformationPackageFactory factory =
        CWMTransformationPackageFactoryHelper.narrow(obj);
      return factory.create_cwmtransformation_package();
    }
    else if (clasePackageHelper.equals("_CorePackage")){
      org.omg.CORBA.Object objCore = readIORRemote(FACTORY_IOR_FILE_CORE);
      CorePackageFactory factoryCore = CorePackageFactoryHelper.narrow(objCore);
      return factoryCore.create_core_package();
    }

    return null;
  }
  public Object loadExistingRefPkg(String clasePackageHelper,String RefIOR) throws Reflective.MofError{
    if (serv==null){
      org.omg.CORBA.Object objT5 = readIORRemote(IOR_SERVIDOR_T5);
      serv = ServiciosHelper.narrow(objT5);
    }
    if (clasePackageHelper.equals("_CWMTransformationPackage")){
      String strobj= serv.readIOR(RefIOR);
      org.omg.CORBA.Object obj = orb.string_to_object(strobj);
      return _CWMTransformationPackageHelper.narrow(obj);
    }
    else if (clasePackageHelper.equals("_CorePackage")){
      String strobj= serv.readIOR(RefIOR);
      org.omg.CORBA.Object objCore = orb.string_to_object(strobj);
      return _CorePackageHelper.narrow(objCore);
    }

    return null;
  }


  public org.omg.CORBA.Object readIORRemote(String strURL) {
    try {
      //System.err.println("Leyendo stringified IOR desde el archivo " + strURL);
      URL url = new URL(strURL);
      URLConnection conx = url.openConnection();
      java.lang.Object contents = conx.getContent();
      String line=null;
      if (contents instanceof InputStream) {
        BufferedReader reader = new BufferedReader(new InputStreamReader((InputStream) contents));
        line = reader.readLine();
        ((InputStream)contents).close();
      }
      if(line!=null){
        return orb.string_to_object(line);
      }
      else{
        return null;
      }
    } catch (IOException ex) {
      System.err.println("Problema opening/reading IOR file: " + ex);
    } catch (org.omg.CORBA.SystemException ex) {
      ex.printStackTrace();
      System.err.println("CORBA system exception in string_to_object: " + ex);
    }
    System.exit(1);
    return null;
  }

  public void writeIORRemote(org.omg.CORBA.Object obj, String strURL) {
    try {
      //System.err.println("Escribiendo stringified IOR al archivo " + strURL);

      URL url = new URL(strURL);
      URLConnection conx = url.openConnection();
      conx.setDoOutput( true );
      PrintWriter out = new PrintWriter(conx.getOutputStream() );
      System.out.println("EScribe :" + orb.object_to_string(obj));
      out.println(orb.object_to_string(obj));
      out.close();
      //return;
    } catch (IOException ex) {
      System.err.println("Problem opening/writing IOR file: " + ex);
    } catch (org.omg.CORBA.SystemException ex) {
      ex.printStackTrace();
      System.err.println("CORBA system exception in object_to_string: " + ex);
    }
    System.exit(1);
  }


  public org.omg.CORBA.Object readIOR(String fileName) {
    try {
      System.err.println("Reading stringified IOR from file " + fileName);
      BufferedReader input = new BufferedReader(new FileReader(fileName));
      String line = input.readLine();
      return orb.string_to_object(line);
    } catch (IOException ex) {
      System.err.println("Problem opening/reading IOR file: " + ex);
    } catch (org.omg.CORBA.SystemException ex) {
      ex.printStackTrace();
      System.err.println("CORBA system exception in string_to_object: " + ex);
    }
    System.exit(1);
    return null;
  }

  public void writeIOR(org.omg.CORBA.Object obj, String fileName) {
    try {
      System.err.println("Writing stringified IOR to file " + fileName);
      FileWriter output = new FileWriter(fileName);
      output.write(orb.object_to_string(obj) + "\n");
      output.close();
      return;
    } catch (IOException ex) {
      System.err.println("Problem opening/writing IOR file: " + ex);
    } catch (org.omg.CORBA.SystemException ex) {
      ex.printStackTrace();
      System.err.println("CORBA system exception in object_to_string: " + ex);
    }
    System.exit(1);
  }
}
